Title: This Week in Rust 595
Number: 595
Date: 2025-04-16
Category: This Week in Rust

Hello and welcome to another issue of *This Week in Rust*!
[Rust](https://www.rust-lang.org/) is a programming language empowering everyone to build reliable and efficient software.
This is a weekly summary of its progress and community.
Want something mentioned? Tag us at
[@thisweekinrust.bsky.social](https://bsky.app/profile/thisweekinrust.bsky.social) on Bluesky or
[@ThisWeekinRust](https://mastodon.social/@thisweekinrust) on mastodon.social, or
[send us a pull request](https://github.com/rust-lang/this-week-in-rust).
Want to get involved? [We love contributions](https://github.com/rust-lang/rust/blob/master/CONTRIBUTING.md).

*This Week in Rust* is openly developed [on GitHub](https://github.com/rust-lang/this-week-in-rust) and archives can be viewed at [this-week-in-rust.org](https://this-week-in-rust.org/).
If you find any errors in this week's issue, [please submit a PR](https://github.com/rust-lang/this-week-in-rust/pulls).

Want TWIR in your inbox? [Subscribe here](https://this-week-in-rust.us11.list-manage.com/subscribe?u=fd84c1c757e02889a9b08d289&id=0ed8b72485).

## Updates from Rust Community

<!--

Dear community contributors:
Please read README.md for guidance on submissions.
Each submitted link should be of the form:

* [Title of the Linked Page](https://example.com/my_article)

If you don't know which category to use, feel free to submit a PR anyway
and just ask the editors to select the category.

-->

### Official
* [March Project Goals Update](https://blog.rust-lang.org/2025/04/08/Project-Goals-2025-March-Update/)

### Newsletters
* [The Embedded Rustacean Issue #43](https://www.theembeddedrustacean.com/p/the-embedded-rustacean-issue-43)

### Project/Tooling Updates
* [Shadertoys ported to Rust GPU](https://rust-gpu.github.io/blog/2025/04/10/shadertoys/)
* [Meilisearch 1.14 - composite embedders, embedding cache, granular filterable attributes, and batch document retrieval by ID](https://www.meilisearch.com/blog/meilisearch-1-14)
* [rust-query 0.4: structural types and other new features](https://blog.lucasholten.com/rust-query-0-4/)

### Observations/Thoughts
* [Rebuilding Prime Video UI with Rust and WebAssembly](https://www.infoq.com/presentations/prime-video-rust/)
* [ALP Rust is faster than C++](https://spiraldb.com/post/alp-rust-is-faster-than-c)
* [what if the poison were rust?](https://flak.tedunangst.com/post/what-if-the-poison-were-rust)
* [A surprising enum size optimization in the Rust compiler](https://jpfennell.com/posts/enum-type-size/)
* [Two Years of Rust](https://borretti.me/article/two-years-of-rust)
* [An ECS lite architecture](https://prideout.net/blog/layout_viewer/#progress-reporting-and-state-machine)
* [A 2025 Survey of Rust GUI Libraries](https://www.boringcactus.com/2025/04/13/2025-survey-of-rust-gui-libraries.html)
* [BTrees, Inverted Indices, and a Model for Full Text Search](https://ohadravid.github.io/posts/2025-04-08-btrees-and-mental-models/)
* [Cutting Down Rust Compile Times From 30 to 2 Minutes With One Thousand Crates](https://www.feldera.com/blog/cutting-down-rust-compile-times-from-30-to-2-minutes-with-one-thousand-crates)
* [SIMD in zlib-rs (part 1): Autovectorization and target features](https://tweedegolf.nl/en/blog/153/simd-in-zlib-rs-part-1-autovectorization-and-target-features)
* [Avoiding memory fragmentation in Rust with jemalloc](https://kerkour.com/rust-jemalloc)
* [video] [Bevy Basics: Who Observes the Observer](https://www.youtube.com/watch?v=8dJtmt19D_s)

### Rust Walkthroughs
* [Rust Type System Deep Dive From GATs to Type Erasure](https://minikin.me/blog/rust-type-system-deep-dive)
* [Async from scratch 1: What's in a Future, anyway? | natkr's ramblings](https://natkr.com/2025-04-10-async-from-scratch-1/)
* [Async from scratch 2: Wake me maybe | natkr's ramblings](https://natkr.com/2025-04-15-async-from-scratch-2/)
* [Building a search engine from scratch, in Rust: part 4](https://jdrouet.github.io/posts/202503311500-search-engine-part-4/)
* [Pretty State Machine Patterns in Rust](https://hoverbear.org/blog/rust-state-machine-pattern/)
* [video] [Build with Naz : Declarative macros in Rust](https://www.youtube.com/watch?v=ZLl2G8tx83s)

### Miscellaneous
* [March 2025 Jobs Report](https://filtra.io/rust/jobs-report/mar-25)
* [Rust resources](https://ongardie.net/misc/rust/)

## Crate of the Week

This week's crate is [wgpu](https://docs.rs/wgpu), a cross-platform graphics and compute library based on [WebGPU](https://gpuweb.github.io/gpuweb/).

Despite a lack of suggestions, llogiq is pleased with his choice.

[Please submit your suggestions and votes for next week][submit_crate]!

[submit_crate]: https://users.rust-lang.org/t/crate-of-the-week/2704

## Calls for Testing
An important step for RFC implementation is for people to experiment with the
implementation and give feedback, especially before stabilization.

If you are a feature implementer and would like your RFC to appear in this list, add a
`call-for-testing` label to your RFC along with a comment providing testing instructions and/or
guidance on which aspect(s) of the feature need testing.

* No calls for testing were issued this week by [Rust](https://github.com/rust-lang/rust/labels/call-for-testing),
  [Rust language RFCs](https://github.com/rust-lang/rfcs/issues?q=label%3Acall-for-testing) or
  [Rustup](https://github.com/rust-lang/rustup/labels/call-for-testing).*

[Let us know](https://github.com/rust-lang/this-week-in-rust/issues) if you would like your feature to be tracked as a part of this list.

### [RFCs](https://github.com/rust-lang/rfcs/issues?q=label%3Acall-for-testing)

### [Rust](https://github.com/rust-lang/rust/labels/call-for-testing)

### [Rustup](https://github.com/rust-lang/rustup/labels/call-for-testing)

If you are a feature implementer and would like your RFC to appear on the above list, add the new `call-for-testing`
label to your RFC along with a comment providing testing instructions and/or guidance on which aspect(s) of the feature
need testing.

## Call for Participation; projects and speakers

### CFP - Projects

Always wanted to contribute to open-source projects but did not know where to start?
Every week we highlight some tasks from the Rust community for you to pick and get started!

Some of these tasks may also have mentors available, visit the task page for more information.

<!-- CFPs go here, use this format: * [project name - title of issue](URL to issue) -->
<!-- * [ - ]() -->
<!-- or if none - *No Calls for participation were submitted this week.* -->

* [rama - add serve command to rama-cli](https://github.com/plabayo/rama/issues/508)
* [rama - add support for include_dir for to ServeDir and related](https://github.com/plabayo/rama/issues/507)
* [rama - add curl module to rama-http-types](https://github.com/plabayo/rama/issues/509)

If you are a Rust project owner and are looking for contributors, please submit tasks [here][guidelines] or through a [PR to TWiR](https://github.com/rust-lang/this-week-in-rust) or by reaching out on [X (formerly Twitter)](https://x.com/ThisWeekInRust) or [Mastodon](https://mastodon.social/@thisweekinrust)!

[guidelines]:https://github.com/rust-lang/this-week-in-rust?tab=readme-ov-file#call-for-participation-guidelines

### CFP - Events

Are you a new or experienced speaker looking for a place to share something cool? This section highlights events that are being planned and are accepting submissions to join their event as a speaker.

<!-- CFPs go here, use this format: * [**event name**](URL to CFP)| Date CFP closes in YYYY-MM-DD | city,state,country | Date of event in YYYY-MM-DD -->
<!-- or if none - *No Calls for papers or presentations were submitted this week.* -->

If you are an event organizer hoping to expand the reach of your event, please submit a link to the website through a [PR to TWiR](https://github.com/rust-lang/this-week-in-rust) or by reaching out on [X (formerly Twitter)](https://x.com/ThisWeekInRust) or [Mastodon](https://mastodon.social/@thisweekinrust)!

## Updates from the Rust Project

480 pull requests were [merged in the last week][merged]

[merged]: https://github.com/search?q=is%3Apr+org%3Arust-lang+is%3Amerged+merged%3A2025-04-08..2025-04-15

#### Compiler

* [detect and provide suggestion for `&raw EXPR`](https://github.com/rust-lang/rust/pull/139392)
* [don't suggest the use of `impl Trait` in closure parameter](https://github.com/rust-lang/rust/pull/138998)
* [make the compiler suggest actual paths instead of visible paths if the visible paths are through any doc hidden path](https://github.com/rust-lang/rust/pull/139364)
* [tell LLVM about impossible niche tags](https://github.com/rust-lang/rust/pull/139098)
* [remove `Nonterminal` and `TokenKind::Interpolated`](https://github.com/rust-lang/rust/pull/124141)
* [re-use `Sized` fast-path](https://github.com/rust-lang/rust/pull/139577)

#### Library

* [add `core::intrinsics::simd::{simd_extract_dyn, simd_insert_dyn}`](https://github.com/rust-lang/rust/pull/137447)
* [initial `UnsafePinned` implementation (Part 1: Libs)](https://github.com/rust-lang/rust/pull/137043)
* [polymorphize `array::IntoIter`'s iterator impl](https://github.com/rust-lang/rust/pull/139430)
* [speed up `String::push` and `String::insert`](https://github.com/rust-lang/rust/pull/124810)
* [std: add `Output::exit_ok`](https://github.com/rust-lang/rust/pull/139554)

#### Cargo

* [added symlink resolution for `workspace-path-hash`](https://github.com/rust-lang/cargo/pull/15400)
* [improved error message when build-dir template var is invalid](https://github.com/rust-lang/cargo/pull/15418)

#### Rustdoc

* [search: add unbox flag to Result aliases](https://github.com/rust-lang/rust/pull/139688)
* [enable Markdown extensions when looking for doctests](https://github.com/rust-lang/rust/pull/139592)

#### Clippy

* [`arbitrary_source_item_ordering` should ignore test modules](https://github.com/rust-lang/rust-clippy/pull/14585)
* [`implicit_return`: better handling of asynchronous code](https://github.com/rust-lang/rust-clippy/pull/14446)
* [accept `self.cmp(other).into()` as canonical `PartialOrd` impl](https://github.com/rust-lang/rust-clippy/pull/14573)
* [add `manual_abs_diff` lint](https://github.com/rust-lang/rust-clippy/pull/14482)
* [consecutive returns dont decrease cognitive Complexity level anymore](https://github.com/rust-lang/rust-clippy/pull/14460)
* [consider nested lifetimes in `mut_from_ref`](https://github.com/rust-lang/rust-clippy/pull/14471)
* [correctly handle bracketed type in `default_constructed_unit_struct`](https://github.com/rust-lang/rust-clippy/pull/14367)
* [deprecate `match_on_vec_items` lint](https://github.com/rust-lang/rust-clippy/pull/14217)
* [do not propose to auto-derive `Clone` in presence of unsafe fields](https://github.com/rust-lang/rust-clippy/pull/14559)
* [fix: `iter_cloned_collect` false positive with custom `From`/`IntoIterator` impl](https://github.com/rust-lang/rust-clippy/pull/14473)
* [fix: `map_entry`: don't emit lint before checks have been performed](https://github.com/rust-lang/rust-clippy/pull/14568)
* [fix: `redundant_clone` false positive in overlapping lifetime](https://github.com/rust-lang/rust-clippy/pull/14237)
* [various fixes for `manual_is_power_of_two`](https://github.com/rust-lang/rust-clippy/pull/14463)

#### Rust-Analyzer

* [ast: return correct types for `make::expr_*` methods](https://github.com/rust-lang/rust-analyzer/pull/19569)
* [add children modules feature](https://github.com/rust-lang/rust-analyzer/pull/19255)
* [add normalizeDriveLetter](https://github.com/rust-lang/rust-analyzer/pull/19578)
* [distribute x64 and aarch64 Linux builds with PGO optimizations](https://github.com/rust-lang/rust-analyzer/pull/19582)
* [fix dyn compatibility code bypassing `callable_item_signature` query](https://github.com/rust-lang/rust-analyzer/pull/19566)
* [fix a small bug with catastrophic effects](https://github.com/rust-lang/rust-analyzer/pull/19558)
* [fix an incorrect `ExpressionStore` that was passed](https://github.com/rust-lang/rust-analyzer/pull/19570)
* [prevent panics when there is a cyclic dependency between closures](https://github.com/rust-lang/rust-analyzer/pull/19579)
* [shadow type by module](https://github.com/rust-lang/rust-analyzer/pull/19461)
* [ignore errors from rustfmt which may trigger error notification](https://github.com/rust-lang/rust-analyzer/pull/19576)
* [port closure inference from rustc](https://github.com/rust-lang/rust-analyzer/pull/19536)

### Rust Compiler Performance Triage

Relatively small changes this week, nothing terribly impactful (positive or negative).

Triage done by **@simulacrum**.
Revision range: [e643f59f..15f58c46](https://perf.rust-lang.org/?start=e643f59f6da3a84f43e75dea99afaa5b041ea6bf&end=15f58c46da79399961a09db0c650a2f90f442e6b&absolute=false&stat=instructions%3Au)

1 Regressions, 3 Improvements, 3 Mixed; 2 of them in rollups
35 artifact comparisons made in total

[Full report here](https://github.com/rust-lang/rustc-perf/blob/master/triage/2025-04-14.md)

### [Approved RFCs](https://github.com/rust-lang/rfcs/commits/master)

Changes to Rust follow the Rust [RFC (request for comments) process](https://github.com/rust-lang/rfcs#rust-rfcs). These
are the RFCs that were approved for implementation this week:

* *No RFCs were approved this week.*

### Final Comment Period

Every week, [the team](https://www.rust-lang.org/team.html) announces the 'final comment period' for RFCs and key PRs
which are reaching a decision. Express your opinions now.

#### Tracking Issues & PRs
##### [Rust](https://github.com/rust-lang/rust/issues?q=is%3Aopen+label%3Afinal-comment-period+sort%3Aupdated-desc)
* [Split elided_lifetime_in_paths into tied and untied](https://github.com/rust-lang/rust/pull/120808)
* [check types of const param defaults](https://github.com/rust-lang/rust/pull/139646)
* [Stabilize flags for doctest cross compilation](https://github.com/rust-lang/rust/pull/137096)
* [Do not remove trivial `SwitchInt` in analysis MIR](https://github.com/rust-lang/rust/pull/139042)
* [Implement a lint for implicit autoref of raw pointer dereference - take 2](https://github.com/rust-lang/rust/pull/123239)
* [Implement `Default` for raw pointers](https://github.com/rust-lang/rust/pull/139535)
* [make abi_unsupported_vector_types a hard error](https://github.com/rust-lang/rust/pull/139309)
* [Stabilize let chains in the 2024 edition](https://github.com/rust-lang/rust/pull/132833)
* [Make closure capturing have consistent and correct behaviour around patterns](https://github.com/rust-lang/rust/pull/138961)
* [Stabilize the `cell_update` feature](https://github.com/rust-lang/rust/pull/134446)

#### Other Areas
* *No Items entered Final Comment Period this week for
  [Rust RFCs](https://github.com/rust-lang/rfcs/labels/final-comment-period),
  [Cargo](https://github.com/rust-lang/cargo/issues?q=is%3Aopen+label%3Afinal-comment-period+sort%3Aupdated-desc),
  [Language Team](https://github.com/rust-lang/lang-team/issues?q=is%3Aopen+label%3Afinal-comment-period+sort%3Aupdated-desc+),
  [Language Reference](https://github.com/rust-lang/reference/issues?q=is%3Aopen+label%3Afinal-comment-period+sort%3Aupdated-desc) or
  [Unsafe Code Guidelines](https://github.com/rust-lang/unsafe-code-guidelines/issues?q=is%3Aopen+label%3Afinal-comment-period+sort%3Aupdated-desc).

Let us know if you would like your PRs, Tracking Issues or RFCs to be tracked as a part of this list.

#### [New and Updated RFCs](https://github.com/rust-lang/rfcs/pulls)
* *No New or Updated RFCs were created this week.*

## Upcoming Events

Rusty Events between 2025-04-16 - 2025-05-14 🦀

### Virtual
* 2025-04-16 | Virtual (Vancouver, BC, CA) | [Vancouver Rust](https://www.meetup.com/vancouver-rust/events/)
    * [**Rust Study/Hack/Hang-out**](https://www.meetup.com/vancouver-rust/events/306231500)
* 2025-04-17 | Virtual and In-Person (Redmond, WA, US) | [Seattle Rust User Group](https://www.meetup.com/join-srug/events/)
    * [**April, 2025 SRUG (Seattle Rust User Group) Meetup**](https://www.meetup.com/seattle-rust-user-group/events/305658454)
* 2025-04-22 | Virtual (Dallas, TX, US) | [Dallas Rust User Meetup](https://www.meetup.com/dallasrust/events/)
    * [**Fourth Tuesday**](https://www.meetup.com/dallasrust/events/305361432)
* 2025-04-23 | Virtual (Cardiff, UK) | [Rust and C++ Cardiff](https://www.meetup.com/rust-and-c-plus-plus-in-cardiff/events/)
    * [**Beyond embedded - OS development in Rust**](https://www.meetup.com/rust-and-c-plus-plus-in-cardiff/events/307036053)
* 2025-04-24 | Virtual (Berlin, DE) | [Rust Berlin](https://www.meetup.com/rust-berlin/events/)
    * [**Rust Hack and Learn**](https://www.meetup.com/rust-berlin/events/300820299)
* 2025-04-24 | Virtual (Charlottesville, VA, US) | [Charlottesville Rust Meetup](https://www.meetup.com/charlottesville-rust-meetup/events/)
    * [**Part 2: Quantum Computers Can’t Rust-Proof This!"**](https://www.meetup.com/charlottesville-rust-meetup/events/306679733)
* 2025-05-03 | Virtual (Kampala, UG) | [Rust Circle Meetup](https://www.eventbrite.com/o/rust-circle-kampala-65249289033)
    * [**Rust Circle Meetup**](https://www.eventbrite.com/e/rust-circle-meetup-tickets-628763176587)
* 2025-05-05 | Virtual (Tel Aviv-Yafo, IL) | [Rust 🦀 TLV](https://www.meetup.com/rust-tlv/events/)
    * [**Tauri: Cross-Platform desktop applications with Rust and web technologies**](https://www.meetup.com/rust-tlv/events/307178592/)
* 2025-05-07 | Virtual (Indianapolis, IN, US) | [Indy Rust](https://www.meetup.com/indyrs/events/)
    * [**Indy.rs - with Social Distancing**](https://www.meetup.com/indyrs/events/302031663)
* 2025-05-08 | Virtual (Berlin, DE) | [Rust Berlin](https://www.meetup.com/rust-berlin/events/)
    * [**Rust Hack and Learn**](https://www.meetup.com/rust-berlin/events/300820300)
* 2025-05-13 | Virtual (Dallas, TX, US) | [Dallas Rust User Meetup](https://www.meetup.com/dallasrust/events/)
    * [**Second Tuesday**](https://www.meetup.com/dallasrust/events/305020415)

### Asia
* 2025-04-22 | Tel Aviv-Yafo, IL | [Rust 🦀 TLV](https://www.meetup.com/rust-tlv/events/)
    * [**In person Rust April 2025 at Braavos in Tel Aviv in collaboration with StarkWare**](https://www.meetup.com/rust-tlv/events/306530984)

### Europe
* 2025-04-19 | Istanbul, TR | [Türkiye Rust Community](https://kommunity.com/turkiye-rust-community/events)
    * [**Rust Konf Türkiye**](https://kommunity.com/turkiye-rust-community/events/rust-konf-turkiye-91f7b3a6)
* 2025-04-23 | London, UK | [London Rust Project Group](https://www.meetup.com/london-rust-project-group/events/)
    * [**Fusing Python with Rust using raw C bindings**](https://www.meetup.com/london-rust-project-group/events/306644439)
* 2025-04-24 | Aarhus, DK | [Rust Aarhus](https://www.meetup.com/rust-aarhus/events/)
    * [**Talk Night at MFT Energy**](https://www.meetup.com/rust-aarhus/events/305809344)
* 2025-04-24 | Edinburgh, UK | [Rust and Friends](https://www.meetup.com/rust-edi/events/)
    * [**Rust and Friends (evening pub)**](https://www.meetup.com/rust-and-friends/events/306911347)
* 2025-04-24 | Manchester, UK | [Rust Manchester](https://www.meetup.com/rust-manchester/events/)
    * [**Rust Manchester April Code Night**](https://www.meetup.com/rust-manchester/events/306899063)
* 2025-04-25 | Edinburgh, UK | [Rust and Friends](https://www.meetup.com/rust-edi/events/)
    * [**Rust and Friends (daytime coffee)**](https://www.meetup.com/rust-and-friends/events/306911357)
* 2025-04-26 | Stockholm, SE | [Stockholm Rust](https://www.meetup.com/stockholm-rust/events/)
    * [**Ferris' Fika Forum #11**](https://www.meetup.com/stockholm-rust/events/307164617)
* 2025-04-29 | London, UK | [Rust London User Group](https://www.meetup.com/rust-london-user-group/events/)
    * [**LDN Talks April 2025 Community Showcase**](https://www.meetup.com/rust-london-user-group/events/307212039)
* 2025-04-29 | Paris, FR | [Rust Paris](https://www.meetup.com/rust-paris/events/)
    * [**Rust meetup #76**](https://www.meetup.com/rust-paris/events/306952202)
* 2025-04-30 | Frankfurt, DE | [Rust Rhein-Main](https://www.meetup.com/rust-rhein-main/events/)
    * [**Kubernetes Operator in Rust**](https://www.meetup.com/rust-rhein-main/events/306772838)
* 2025-05-01 | Nürnberg, DE | [Rust Nuremberg](https://www.meetup.com/rust-noris/events/)
    * [**Hackers Hike 0x0**](https://www.meetup.com/rust-noris/events/305522254)
* 2025-05-06 - 2025-05-07 | Paris, FR | [WebAssembly and Rust Meetup](https://www.meetup.com/wasm-rust-meetup/)
    * [**GOSIM AI Paris 2025**](https://www.meetup.com/wasm-rust-meetup/events/306530699/)
* 2025-05-06 | Paris, FR | [WebAssembly and Rust Meetup (Wasm Empowering AI)](https://www.meetup.com/wasm-rust-meetup/events/)
    * [**GOSIM AI Paris 2025 (Discount available)**](https://www.meetup.com/wasm-rust-meetup/events/306530699)
* 2025-05-07 | Madrid, ES | [MadRust](https://www.meetup.com/madrust/events/)
    * [**VII Lenguajes, VII Perspectivas, I Problema**](https://www.meetup.com/madrust/events/307030185)
* 2025-05-07 | Oxford, UK | [Oxford Rust Meetup Group](https://www.meetup.com/oxford-rust-meetup-group/events/)
    * [**Oxford Rust and C++ social**](https://www.meetup.com/oxford-rust-meetup-group/events/306541571)
* 2025-05-08 | Gdansk, PL | [Rust Gdansk](https://www.meetup.com/rust-gdansk/events/)
    * [**Rust Gdansk Meetup #8**](https://www.meetup.com/rust-gdansk/events/307281434)
* 2025-05-08 | London, UK | [London Rust Project Group](https://www.meetup.com/london-rust-project-group/events/)
    * [**Adopting Rust (Hosted by Lloyds bank)**](https://www.meetup.com/london-rust-project-group/events/307085179)
* 2025-05-13 | Amsterdam, NL | [RustNL](https://www.meetup.com/rust-amsterdam/events/)
    * [**RustWeek 2025 announcement**](https://www.meetup.com/rust-nederland/events/305227330)
* 2025-05-13 - 2025-05-17 | Utrecht, NL | [Rust NL](https://www.meetup.com/Rust-Nederland/)
    * [**RustWeek 2025**](https://dev.events/conferences/rust-week-2025-utcccotp)
* 2025-05-14 | Reading, UK | [Reading Rust Workshop](https://www.meetup.com/reading-rust-workshop/events/)
    * [**Reading Rust Meetup**](https://www.meetup.com/reading-rust-workshop/events/305045447)

### North America
* 2025-04-17 | Mountain View, CA, US | [Hacker Dojo](https://www.meetup.com/hackerdojo/events/)
    * [**RUST MEETUP at HACKER DOJO**](https://www.meetup.com/hackerdojo/events/xdxtqtyhcgbwb)
* 2025-04-17 | Nashville, TN, US | [Music City Rust Developers](https://www.meetup.com/music-city-rust-developers/events/)
    * [**Using Rust For Web Series 1 : Why HTMX Is Bad**](https://www.meetup.com/music-city-rust-developers/events/304333092)
* 2025-04-17 | Redmond, WA, US | [Seattle Rust User Group](https://www.meetup.com/join-srug/events/)
    * [**April, 2025 SRUG (Seattle Rust User Group) Meetup**](https://www.meetup.com/seattle-rust-user-group/events/305658454)
* 2025-04-22 | Detroit, MI, US | [Detroit Rust](https://www.meetup.com/detroitrust/events/)
    * [**Rust Community Meet and Conference Report - Ann Arbor**](https://www.meetup.com/detroitrust/events/307221924)
* 2025-04-23 | Austin, TX, US | [Rust ATX](https://www.meetup.com/rust-atx/events/)
    * [**Rust Lunch - Fareground**](https://www.meetup.com/rust-atx/events/307089940)
* 2025-04-23 | Austin, TX, US | [Rust ATX](https://www.meetup.com/rust-atx/events/)
    * [**Rust Lunch - Fareground**](https://www.meetup.com/rust-atx/events/xvkdgtyhcgbfc)
 2025-04-23 | Spokane, WA, US | [Spokane Rust](https://www.meetup.com/spokane-rust/events/)
    * [**Community Show & Tell at Fuel Coworking**](https://www.meetup.com/spokane-rust/events/307228157)
* 2025-04-24 | Atlanta, GA, US | [Rust Atlanta](https://www.meetup.com/rust-atl/events/)
    * [**3rd 3RD TIME OMG YES!**](https://www.meetup.com/rust-atl/events/307152133)
* 2025-04-25 | Boston, MA, US | [Boston Rust Meetup](https://www.meetup.com/bostonrust/events/)
    * [**Ball Square Rust Lunch, Apr 25**](https://www.meetup.com/bostonrust/events/306844343)
* 2025-05-01 | Saint Louis, MO, US | [STL Rust](https://www.meetup.com/stl-rust/events/)
    * [**SIUE Capstone Project reflections on Rust**](https://www.meetup.com/stl-rust/events/304026152)
* 2025-05-03 | Boston, MA, US | [Boston Rust Meetup](https://www.meetup.com/bostonrust/events/)
    * [**Boston Common Rust Lunch, May 3**](https://www.meetup.com/bostonrust/events/306845368)
* 2025-05-08 | México City, MX | [Rust MX](https://www.meetup.com/rust-mx/events/)
    * [**Calculando con el compilador: Compiler time vs Run time**](https://www.meetup.com/rust-mx/events/307015601)
* 2025-05-08 | Portland, OR, US | [PDXRust](https://www.meetup.com/pdxrust/events/)
    * [**Apache DataFusion: A Fast, Extensible, Modular Analytic Query Engine in Rust**](https://www.meetup.com/pdxrust/events/307288436)
* 2025-05-11 | Boston, MA, US | [Boston Rust Meetup](https://www.meetup.com/bostonrust/events/)
    * [**Porter Square Rust Lunch, May 11**](https://www.meetup.com/bostonrust/events/306845728)

### Oceania
* 2025-04-22 | Barton, AC, AU | [Canberra Rust User Group](https://www.meetup.com/rust-canberra/events/)
    * [**April Meetup**](https://www.meetup.com/rust-canberra/events/306425557)

If you are running a Rust event please add it to the [calendar] to get
it mentioned here. Please remember to add a link to the event too.
Email the [Rust Community Team][community] for access.

[calendar]: https://www.google.com/calendar/embed?src=apd9vmbc22egenmtu5l6c5jbfc%40group.calendar.google.com
[community]: mailto:community-team@rust-lang.org

## Jobs
<!--

Rust Jobs:

TWiR has stopped featuring individual job postings. You can read more about this change here:

https://github.com/rust-lang/this-week-in-rust/issues/3412

-->

Please see the latest [Who's Hiring thread on r/rust](https://www.reddit.com/r/rust/comments/1jttzz4/official_rrust_whos_hiring_thread_for_jobseekers/)

# Quote of the Week

> IEEE 754 floating point, proudly providing counterexamples since 1985!

– [Johannes Dahlström on rust-internals](https://internals.rust-lang.org/t/highlight-differences-in-assert-eq/22722/4)

Thanks to [Ralf Jung](https://users.rust-lang.org/t/twir-quote-of-the-week/328/1665) for the suggestion!

[Please submit quotes and vote for next week!](https://users.rust-lang.org/t/twir-quote-of-the-week/328)

*This Week in Rust is edited by: [nellshamrell](https://github.com/nellshamrell), [llogiq](https://github.com/llogiq), [cdmistman](https://github.com/cdmistman), [ericseppanen](https://github.com/ericseppanen), [extrawurst](https://github.com/extrawurst), [U007D](https://github.com/U007D), [joelmarcey](https://github.com/joelmarcey), [mariannegoldin](https://github.com/mariannegoldin), [bennyvasquez](https://github.com/bennyvasquez), [bdillo](https://github.com/bdillo)*

*Email list hosting is sponsored by [The Rust Foundation](https://foundation.rust-lang.org/)*

<small>[Discuss on r/rust](https://www.reddit.com/r/rust/comments/1k107ip/this_week_in_rust_595/)</small>
