# Assembling This Week in Rust

Every week your editors assemble a collection of links, quotes, crates, and more for Rustaceans around the globe. While each section is managed by an editor or more, overall editoral and publishing guidance is provided by [@nellshamrell](https://github.com/nellshamrell). 

This documents the general process for assembling each of the sections.

## Updates from the Rust Community

The full editoral staff works together to cover this section, but the primary contributors are [@extrawurst](https://github.com/extrawurst), [@ericseppanen](https://github.com/ericseppanen), and [@cdmistman](https://github.com/cdmistman). 

Many of the links featured in this section come from pull requests to this GitHub repo and tweets to the [@ThisWeekInRust](https://twitter.com/ThisWeekInRust).

Others, however, come from editors scanning various places that people tend to post Rust links. These include:

* [r/rust](https://www.reddit.com/r/rust/)
* [Hacker News](https://news.ycombinator.com/)
* [dev.to](https://dev.to/)

Any link included in This Week in Rust should follow the guidelines in [What do we look for when considering whether to include something in This Week in Rust?](https://github.com/rust-lang/this-week-in-rust#what-do-we-look-for-when-considering-whether-to-include-something-in-this-week-in-rust).

## Crate of the Week

[@llogiq](https://github.com/llogiq) covers this section.

The crates are nominated and voted on in [this forums thread](https://users.rust-lang.org/t/crate-of-the-week/2704/784).

## Quote of the Week

[@llogiq](https://github.com/llogiq) covers this section.

The quotes are nominated and voted on in [this forums thread](https://users.rust-lang.org/t/twir-quote-of-the-week/328).

## Call for Participation Links

[@bennyvasquez](https://github.com/bennyvasquez) covers this section.

These are submitted in [this forums thread](https://users.rust-lang.org/t/twir-call-for-participation/4821).

## Updates from Rust Project

[@llogiq](https://github.com/llogiq) covers this section and has scripts that collect these links.

## RFCs and FCP Issues/Pull Requests

[@U007D](https://github.com/U007D) currently covers this section!

These are collected using GitHub queries:
* [Recently approved RFCs](https://github.com/rust-lang/rfcs/commits/master)
* [RFCs in Final Comment Period](https://github.com/rust-lang/rfcs/labels/final-comment-period)
* [Issues/PRs in Final Comment Period](https://github.com/rust-lang/rust/labels/final-comment-period)
* [New RFCs](https://github.com/rust-lang/rfcs/pulls)

## Events

[@andrewpollack](https://github.com/andrewpollack) and [@mariannegoldin](https://github.com/mariannegoldin) currently cover this section.

These are collected from the [Rust Community Calendar](https://calendar.google.com/calendar/u/0/embed?src=apd9vmbc22egenmtu5l6c5jbfc@group.calendar.google.com). We generally only feature events that are upcoming in the next 4 weeks.

Most events include a meetup link, it's important to follow the link and check the date on the meetup page. If the date on the meetup page is different from the date on the calendar, the date on the meetup page should take precedence.

## Jobs

This section has been updated to refer to the most recent ['Who's Hiring'](https://www.reddit.com/r/rust/search/?q=who%27s%20hiring&restrict_sr=1&sort=new) thread on the [Rust subreddit](https://www.reddit.com/r/rust/). 
